import sys
#sys.path.insert(0, 'scripts');
import uc
import die
import fasta

FileName = sys.argv[1]
pctIdent = sys.argv[2] #percent identity, will be used in the label
pctIdent = 1.0 - float(pctIdent);
multiSample = (sys.argv[3]=='True') #whether the input file has multiple samples (using barcode label)

def GetSampleId(Label):
	Fields = Label.split(";")
	for Field in Fields:
		if Field.startswith("barcodelabel="):
			return Field[13:]
	die.Die("barcodelabel= not found in read label '%s'" % Label)

def OnRec():
	global OTUs, Samples, OTUTable
	if uc.Type != 'H':
		return

	OTUId = uc.TargetLabel
	if OTUId not in OTUIds:
		OTUIds.append(OTUId)
		OTUTable[OTUId] = {}

	SampleId = GetSampleId(uc.QueryLabel)
	if SampleId not in SampleIds:
		SampleIds.append(SampleId)

	N = fasta.GetSizeFromLabel(uc.QueryLabel, 1)
	try:
		OTUTable[OTUId][SampleId] += N
	except:
		OTUTable[OTUId][SampleId] = N

OTUIds = []
SampleIds = []
OTUTable = {}

uc.ReadRecs(FileName, OnRec)

#Header line
if (multiSample):
  s = "OTUId\t#OTUs\tsample"
else:
  s = "OTUId\t#OTUs"

for OTUId in OTUIds:
  s += "\t" + OTUId
print s

for SampleId in SampleIds:
  if (multiSample):
    s = str(pctIdent) + "\t" + SampleId
  else: 
    s = str(pctIdent)
  s += "\t" + str(len(OTUIds))
  for OTUId in OTUIds:
    try:
      n = OTUTable[OTUId][SampleId]
    except:
      n = 0;
    s += "\t" + str(n)
  print s
